// listplug.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "listplug.h"


#include "trans.h"

#define supportedextension1 ".mdl"
/* Note: in C, double quotes inside a string need to be escaped with a backslash!  */
#define parsefunction "EXT=\"MDL\" & [0]=\"I\" & [1]=\"D\" & [2]=\"S\" & [3]=\"T\""

HINSTANCE hinst;
HMODULE FLibHandle=0;
char inifilename[MAX_PATH]="lsplugin.ini";  // Unused in this plugin, may be used to save data

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			hinst=(HINSTANCE)hModule;
			break;
		case DLL_PROCESS_DETACH:
			if (FLibHandle)
				FreeLibrary(FLibHandle);
			FLibHandle=NULL;
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
    }
    return TRUE;
}

char* strlcpy(char* p,char*p2,int maxlen)
{
	if ((int)strlen(p2)>=maxlen) {
		strncpy(p,p2,maxlen);
		p[maxlen]=0;
	} else
		strcpy(p,p2);
	return p;
}


HWND __stdcall ListLoad(HWND ParentWin, char* FileToLoad, int ShowFlags)
{

	//MessageBox(NULL, "Modelviewer - Start", "Notice", MB_OK);

	int pf;
	HDC hDC;	//Device Context
	HGLRC hRC;	//OpenGL (Rendering) Context
	PIXELFORMATDESCRIPTOR pfd;
	WNDCLASS wc;
	HWND hwnd;
	RECT r;
	char *p;
	static bool reg = false;

	if (ShowFlags & lcp_forceshow==0) {  // don't check extension in this case!
		p=strrchr(FileToLoad,'\\');
		if (!p)
			return NULL;
		p=strrchr(p,'.');
		if (!p || (stricmp(p, supportedextension1)!=0))
			return NULL;
	}
	//MessageBox(NULL, "Modelviewer - file accepted", "Notice", MB_OK);


	if (!reg) {
		reg = true;
		wc.style         = CS_OWNDC;
		wc.lpfnWndProc   = (WNDPROC)WindowProc;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		wc.hInstance     = hinst;
		wc.hIcon         = LoadIcon(NULL, IDI_WINLOGO);
		wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = NULL;
		wc.lpszMenuName  = NULL;
		wc.lpszClassName = "OpenGL";
		if (!RegisterClass(&wc)) {
			MessageBox(NULL, "RegisterClass() failed:  "
			"Cannot register window class.", "Error", MB_OK);
			return NULL;
		}
	}


	GetClientRect(ParentWin,&r);
	// Create window invisbile, only show when data fully loaded!
	hwnd=CreateWindow("OpenGL", "", WS_CHILD, r.left, r.top, r.right-r.left, r.bottom-r.top, ParentWin, NULL, hinst, NULL);

	if (hwnd) {

		hDC = GetDC(hwnd);
		/* there is no guarantee that the contents of the stack that become
		the pfd are zeroed, therefore _make sure_ to clear these bits. */
		memset(&pfd, 0, sizeof(pfd));
		pfd.nSize        = sizeof(pfd);
		pfd.nVersion     = 1;
		pfd.dwFlags      = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
		pfd.iPixelType   = PFD_TYPE_RGBA;
		pfd.cColorBits   = 32;
		pf = ChoosePixelFormat(hDC, &pfd);
		if (pf == 0) {
			MessageBox(NULL, "ChoosePixelFormat() failed:  "
				"Cannot find a suitable pixel format.", "Error", MB_OK); 
			return NULL;
		} 
 
		if (SetPixelFormat(hDC, pf, &pfd) == FALSE) {
			MessageBox(NULL, "SetPixelFormat() failed:  "
				"Cannot set format specified.", "Error", MB_OK);
		return NULL;
		} 
		DescribePixelFormat(hDC, pf, sizeof(PIXELFORMATDESCRIPTOR), &pfd);
		ReleaseDC(hwnd, hDC);

		hDC = GetDC(hwnd);
		hRC = wglCreateContext(hDC);
		wglMakeCurrent(hDC, hRC);

		//======================================================================
		//MessageBox(NULL, "Modelviewer - Init", "Notice", MB_OK);
		init(FileToLoad);	//init the modelviewer
		//======================================================================		
		
	}
	if (hwnd)
		ShowWindow(hwnd,SW_SHOW);
	else
		MessageBox(NULL, "Modelviewer - No Handle", "Error", MB_OK);

	return hwnd;
}





void __stdcall ListCloseWindow(HWND ListWin)
{
	HDC hDC;	//Device Context
	HGLRC hRC;	//OpenGL (Rendering) Context

	hDC = GetDC(ListWin);
	hRC = wglGetCurrentContext();
	wglMakeCurrent(NULL, NULL);
	ReleaseDC(ListWin, hDC);
	wglDeleteContext(hRC);
	DestroyWindow(ListWin);
	return;
}

void __stdcall ListGetDetectString(char* DetectString,int maxlen)
{
	strlcpy(DetectString,parsefunction,maxlen);
}

void __stdcall ListSetDefaultParams(ListDefaultParamStruct* dps)
{
	strlcpy(inifilename,dps->DefaultIniName,MAX_PATH-1);
}
